import pandas as pd
from IPython.display import display, HTML

from lhcsmapi.dbsignal.SignalAnalysis import SignalAnalysis
from lhcsmapi.reference.Reference import Reference


class CurrentLeadsAnalysis(object):

    @staticmethod
    def analyze_current_leads(u_leads_df):

        leads_threshold_df = Reference.get_current_leads_parameters()

        pattern = [True, True]
        leads_analysis_df = pd.DataFrame(index=u_leads_df.columns, columns=['points_above_threshold'])
        for signal in ['U_HTS', 'U_RES']:
            for col in u_leads_df.filter(regex=signal).columns:
                above_threshold_df = u_leads_df.apply(
                    lambda row: abs(row[col]) > leads_threshold_df.loc[signal, 'threshold'], axis=1)
                rows_matching_pattern, _ = SignalAnalysis.find_rows_with_exact_pattern_in_series(above_threshold_df,
                                                                                                 pattern)
                leads_analysis_df.loc[col, 'points_above_threshold'] = len(rows_matching_pattern)

        if not leads_analysis_df['points_above_threshold'].all():
            return True
        else:
            print('The following signals have at least two consecutive points above the threshold')
            display(HTML(leads_analysis_df[leads_analysis_df['points_above_threshold'] > 0].to_html()))
            return False