from tqdm.notebook import tqdm

from lhcsmapi.metadata.SignalMetadata import SignalMetadata
from lhcsmapi.dbsignal.Signal import Signal


class NqpsQuery(object):

    @staticmethod
    def query_nqps_voltage(circuit_type, circuit_name, timestamp_fgc, *, system, signal, ldb):
        NQPS_SIGNAL_template = SignalMetadata.get_signal_name(circuit_type, circuit_name, system, 'CALS', signal)
        name, wildcards = SignalMetadata.get_wildcard_for_circuit_system_db_signal(circuit_type, circuit_name, system, 'CALS',
                                                                                   signal)
        NQPS_SIGNAL = [NQPS_SIGNAL_template.replace('%MAGNET%', wildcard) for wildcard in wildcards]

        nqps_signal_dfs = []
        for i in tqdm(range(len(NQPS_SIGNAL)), desc='Querying CALS'):
            nqps_signal_df = Signal().read('cals', signal=NQPS_SIGNAL[i], t_start=(timestamp_fgc, 'ns'),
                                           duration=[(10, 's'), (350, 's')], ldb=ldb)
            nqps_signal_sync_df = nqps_signal_df.set_index((nqps_signal_df.index.values - timestamp_fgc * 1e-9))
            nqps_signal_dfs.append(nqps_signal_sync_df)

        return nqps_signal_dfs