from lhcsmapi.dbsignal.Signal import Signal
from lhcsmapi.metadata.SignalMetadata import SignalMetadata


class PicQuery(object):

    @staticmethod
    def get_st_abort_pic_timestamp(circuit_type, circuit_name, timestamp, ldb, duration=[(1, 's'), (60, 's')]):
        ST_ABORT_PIC = SignalMetadata.get_signal_name(circuit_type, circuit_name, 'PIC', 'CALS', 'ST_ABORT_PIC')[0]
        st_abort_pic_df = Signal().read('CALS', signal=ST_ABORT_PIC, t_start=timestamp, duration=duration, ldb=ldb)

        if len(st_abort_pic_df) == 0:
            ST_ABORT_PIC = SignalMetadata.get_signal_name(circuit_type, circuit_name, 'PIC', 'CALS', 'ST_ABORT_PIC')[1]
            st_abort_pic_df = Signal().read('CALS', signal=ST_ABORT_PIC, t_start=timestamp, duration=duration, ldb=ldb)

        if len(st_abort_pic_df) == 0:
            print('Empty signal ST_ABORT_PIC, returning 0!')
            return 0

        return st_abort_pic_df.index[0] * 1e+9

    @staticmethod
    def get_st_abort_pic_timestamp_nxcals(circuit_type, circuit_name, timestamp_fgc, spark,
                                          duration=[(1, 's'), (60, 's')]):
        ST_ABORT_PIC = SignalMetadata.get_signal_name(circuit_type, circuit_name, 'PIC', 'CALS', 'ST_ABORT_PIC')[0]
        st_abort_pic_df = Signal().read('nxcals', signal=ST_ABORT_PIC, t_start=timestamp_fgc, duration=duration,
                                        spark=spark, nxcals_system='WINCCOA')

        if len(st_abort_pic_df[st_abort_pic_df[ST_ABORT_PIC] == 0]) == 0:
            ST_ABORT_PIC = SignalMetadata.get_signal_name(circuit_type, circuit_name, 'PIC', 'CALS', 'ST_ABORT_PIC')[1]
            st_abort_pic_df = Signal().read('nxcals', signal=ST_ABORT_PIC, t_start=timestamp_fgc, duration=duration,
                                            spark=spark, nxcals_system='WINCCOA')

        if len(st_abort_pic_df[st_abort_pic_df[ST_ABORT_PIC] == 0]) == 0:
            print('Empty signal ST_ABORT_PIC, returning 0!')
            return 0

        return st_abort_pic_df[st_abort_pic_df[ST_ABORT_PIC] == 0].index[0]
