import datetime

def unix_time_in_nano_second2datatime(input_time_stamp_in_nano_second):
    """ Function converts from the unix time in ns to a date time object """
    format_str = "%Y-%m-%d %H:%M:%S.%M"
    return datetime.datetime.fromtimestamp(input_time_stamp_in_nano_second / 1e9).strftime(format_str)

def datetime2unixtime_in_second(input_datetime):
    """ Function converts from the input date time as a datetime object to ns """
    return (input_datetime - datetime.datetime(1970, 1, 1)).total_seconds()

def datetime2unixtime_in_nano_second(input_datetime):
    """ Function converts from the input date time as a datetime object to second """
    return (input_datetime - datetime.datetime(1970, 1, 1)).total_seconds() * 1e9

def timestamp2unixtime_in_nano_second(input_datetime):
    """ Function converts from the input date time as a timestamp object to ns """
    return input_datetime.value