import pandas as pd
from lhcsmapi.Time import Time
import sys

def convert_pm_file_name_to_timestamp_string(pm_file_name):
    sdds_file_name = pm_file_name.split('/')[-1]
    date = sdds_file_name.split('__')[1].split('-')[0]
    time = sdds_file_name.split('-')[1].split('.')[0]
    msec = sdds_file_name.split('.')[-2]

    # 2014-11-26 16:04:13.613
    return '20{}-{}-{} {}:{}:{}.{}'.format(date[0:2], date[2:4], date[4:],
                                                       time[0:2], time[2:4], time[4:],
                                                       msec)


def process_ref_discharges(ref_file_name, file_prefix, colname):
    try:
        ref_discharges = pd.read_csv(ref_file_name)
        ref_discharges['Timestamp String'] = ref_discharges.apply(lambda col: convert_pm_file_name_to_timestamp_string(col['PMFile']), axis=1)
        ref_discharges['Timestamp'] = ref_discharges.apply(lambda col: Time.to_unix_timestamp(col['Timestamp String']), axis=1)
        ref_discharges = ref_discharges[[colname, 'Timestamp String', 'Timestamp']]
        ref_discharges.to_csv('{}_ReferenceDischarges.csv'.format(file_prefix))
    except:
        print("process_ref_discharges exception ", sys.exc_info())

process_ref_discharges('refDischarges_MB_postLS1.csv', 'RB', 'Cell')
process_ref_discharges('refDischarges_MQ_postLS1.csv', 'RQ', 'Cell')
process_ref_discharges('refDischarges_IPD_postLS1.csv', 'IPD', 'Magnet')
process_ref_discharges('refDischarges_IPQ_postLS1.csv', 'IPQ', 'Magnet')
process_ref_discharges('refDischarges_IT_postLS1.csv', 'IT', 'Magnet')

